#!/bin/bash

sizes=(16 24 32 48 64 256)
root_dir='hicolor'
ico_dir='ico'
app_icons='../scalable/apps/*'

cd $root_dir
mkdir -p $ico_dir
cd $ico_dir

cp $app_icons .

icons=$(find *.svg -maxdepth 0 -type f)

for icon in $icons
do
	png_name=${icon/.svg/.png}
	ico_name=${icon/.svg/.ico}
	
	for size in "${sizes[@]}"
	do 
		inkscape --export-filename $size'_'$png_name -w $size -h $size $icon
		echo
	done
	
	pngs=$(find *$png_name -maxdepth 0 -type f)
	convert $pngs $ico_name
	
	rm $pngs
	rm $icon
done

exit 0;
